#include "testlib.h"

#include<bits/stdc++.h>
#define FOR(i,a,b) for (int i=(a),_b=(b);i<=_b;i=i+1)
#define FORD(i,b,a) for (int i=(b),_a=(a);i>=_a;i=i-1)
#define REP(i,n) for (int i=0,_n=(n);i<_n;i=i+1)
#define FORE(i,v) for (__typeof((v).begin()) i=(v).begin();i!=(v).end();i++)
#define ALL(v) (v).begin(),(v).end()
#define fi   first
#define se   second
#define MASK(i) (1LL<<(i))
#define BIT(x,i) (((x)>>(i))&1)
#define div   ___div
#define next   ___next
#define prev   ___prev
#define left   ___left
#define right   ___right
#define __builtin_popcount __builtin_popcountll
using namespace std;
template<class X,class Y>
    void minimize(X &x,const Y &y) {
        if (x>y) x=y;
    }
template<class X,class Y>
    void maximize(X &x,const Y &y) {
        if (x<y) x=y;
    }
template<class T>
    T Abs(const T &x) {
        return (x<0?-x:x);
    }

/* Author: GS.PVH */

/** END OF TEMPLATE - ACTUAL SOLUTION COMES HERE **/

int MOD;

struct Matrix {
    int m, n, d[3][3];

    Matrix(int _m = 0, int _n = 0) {
        m = _m; n = _n;
        memset(d, 0, sizeof d);
    }

    Matrix operator * (const Matrix &a) const {
        int x = m;
        int y = n;
        int z = a.n;

        Matrix res(x, z);
        REP(i, x) REP(j, y) REP(k, z) res.d[i][k] = (res.d[i][k] + 1LL * d[i][j] * a.d[j][k]) % MOD;
        return res;
    }

    Matrix operator ^ (long long k) const {
        Matrix res(n, n);
        Matrix mul = *this;

        REP(i, n) REP(j, n) res.d[i][j] = i == j ? 1 : 0;

        while (k > 0) {
            if (k & 1) res = res * mul;
            mul = mul * mul;
            k >>= 1;
        }

        return res;
    }
};

int getFib(long long k, int mod) {
    MOD = mod;

    Matrix res(1, 2);
    res.d[0][0] = 0; res.d[0][1] = 1;
    Matrix mul(2, 2);
    mul.d[0][0] = 0; mul.d[0][1] = 1;
    mul.d[1][0] = 1; mul.d[1][1] = 1;

    res = res * (mul ^ k);
    return res.d[0][0];
}

#define MAX   1000100
int value[MAX];

bool checkAnswer(InStream &stream, long long s, int n, int mod, int testID) {
    int k = stream.readInt(0, n, format("Test %d, subset size", testID));
    if (k == 0) return false;

    set<int> used;
    int sum = 0;
    REP(love, k) {
        int id = stream.readLong(s, s + n - 1, format("Test %d, element %d", testID, love + 1)) - s;
        if (!used.insert(id).se)
            stream.quitf(_wa, "Test %d: Element %lld has been duplicated", testID, id + s);
        sum += value[id];
        if (sum >= mod) sum -= mod;
    }

    if (sum != 0) stream.quitf(_wa, "Test %d: Sum of subset is not divisible by %d\n", testID, mod);
    return true;
}
void check(long long s, int n, int mod, int testID) {
    REP(i, 2) value[i] = getFib(s + i, mod);
    FOR(i, 2, n) {
        value[i] = value[i - 1] + value[i - 2];
        if (value[i] >= mod) value[i] -= mod;
    }

    bool exp = checkAnswer(ans, s, n, mod, testID);
    bool res = checkAnswer(ouf, s, n, mod, testID);

    if (exp && !res) quitf(_wa, "Test %d: Contestant thinks that solution does not exist, but it does", testID);
    if (!exp && res) quitf(_fail, "Test %d: Jury thinks that solution does not exist, but it does", testID);
}

int main(int argc, char* argv[]) {
#ifdef THEMIS
    registerTestlibThemis("fibseq.inp", "fibseq.out");
#else
    registerTestlibCmd(argc, argv);
#endif // THEMIS

    int t = inf.readInt();
    FOR(testID, 1, t) {
        int n = inf.readInt(1, (int)1e6);
        long long s = inf.readLong(1, (long long)1e15);
        int mod = inf.readInt(1, n);
        check(s, n, mod, testID);
    }

    quitf(_ok, "Ơ mây ding, gút chóp em %d correct subsets!\n", t);
}

/*** LOOK AT MY CODE. MY CODE IS AMAZING :D ***/
